#ifndef PBMOUTPUTDEV_H
#define PBMOUTPUTDEV_H

#ifdef __GNUC__
#pragma interface
#endif

#include <stddef.h>
#include "config.h"
#include "XOutputDev.h"

//------------------------------------------------------------------------

class PBMOutputDev: public XOutputDev 
{
public:
	static PBMOutputDev *makePBMOutputDev(char *displayName,char *fileRootA);
	static void killPBMOutputDev(PBMOutputDev *out);
	virtual ~PBMOutputDev();
	
	//----- initialization and control
	int getWidth()	{return	width;}
	int getHeight()	{return height;}
	int getCurPage(){return curPage;}

	// Start a page.
	virtual void startPage(int pageNum, GfxState *state);
	// End a page.
	virtual void endPage();
	void drawImageMask(GfxState *state, Object *ref, Stream *str,
				   int width, int height, GBool invert,
				   GBool inlineImg);
	void drawImage(GfxState *state, Object *ref, Stream *str,
			       int width, int height,
			       GfxImageColorMap *colorMap, 
			       int *maskColors,GBool inlineImg);

	TextPage *getPageText(){return text;}
	vector<SHTMLINK> *getHtmLink(){return &m_aryHtmLink;}
private:
	
	PBMOutputDev(Display *displayA, int screenA,
		Pixmap pixmapA, Window dummyWinA,
		int invertA, char *fileRootA);
	
	char *fileRoot;
	char *fileName;
	int curPage;
	
	GBool dumpJPEG;		// set to dump native JPEG files
	int imgNum;			// current image number

	Display *display;
	int screen;
	Pixmap pixmap;
	Window dummyWin;
	int width, height;
	int invert;
};

#endif
