#if !defined(AFX_SHADOW_H__105223A6_8A70_4B93_935C_A0E4903489D2__INCLUDED_)
#define AFX_SHADOW_H__105223A6_8A70_4B93_935C_A0E4903489D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CShadow  
{
public:

	CShadow();

	virtual ~CShadow();

	bool DrawShadow(CDC *pDC);

	inline COLORREF ColorAdjustLuma(COLORREF hRef, int nIntensity);

	CRect UpdateShadow(CDC *pDC);

	int SetBorderLength(int nLen) {
		nBorder = nLen;
	};

	int SetIntensity() {
		return nIntensity;
	};

	void GetIntensity(int nInt) {
		nIntensity = nInt;
	};

	void RemoveShadow();
	bool RedrawShadow();

	void RedrawOldShadow();
	void RedrawOldShadowIgnore(CRect rIgnore);

	bool DrawShadow(CWnd *pWnd);
	bool DrawShadow(CRect r);

	bool HasMoved() {

		if(!bDrawn)
			return bDrawn;

		CRect r;
		pSaveWnd->GetWindowRect(r);

		if(r != rcSave)
			return true;

		return false;
	};
		
	bool IsDrawn() {
		return bDrawn;
	}

	CDC *pDestDC;

private :

	CWnd *pSaveWnd;
	CRect rcSave;

	int nBorder;
	int nIntensity;

	bool bDrawn;

	CBitmap m_Bitmap[4];
	CBitmap *m_OldBitmap[4];

	CDC hRightDC;
	CDC hBottomDC;

	CDC hShadowRightDC;
	CDC hShadowBottomDC;

	CRect GetRightRect(CRect r);
	CRect GetBottomRect(CRect r);
};

#endif // !defined(AFX_SHADOW_H__105223A6_8A70_4B93_935C_A0E4903489D2__INCLUDED_)
